Const Selecting = 0
Const Moving = 1
Const Eating = 2
Const Eating2 = 3
Const Marking = 4
Const Clearing = 5
Const Sinking = 6
Const GameOver = 7
Const HighMsg = 8
Const EnterName = 9
Const OutMsg = 10      'Place go down to below to when entering name
Const GameOverMsg = 11
Const ResetDelay = 12

Const hiFile = "high.dat"

#Include "columns.bi"
#Include "colsvga.bas"

Redim Shared Game(1) As GameData
Dim Shared As Integer Times(9) = {36,30,24,19,14,9,6,4,2,1}


Function MvDown (ByVal Player As Integer) As Integer
  Dim As Integer i
  If Game(Player).CurY = 0 Then Exit Function
  If Game(Player).Top(Game(Player).CurX) >= Game(Player).CurY Then Exit Function
  If Game(Player).Board(Game(Player).CurX, Game(Player).CurY - 1) Then Exit Function
  Game(Player).CurY -= 1
  If Game(Player).CurY < 9 Then
    ShowJewel(Player, Game(Player).CurX, 3 + Game(Player).CurY, 0)
  End If
  For i = 0 To 2
    If i + Game(Player).CurY < 12 Then
      ShowJewel(Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i))
    End If
  Next i
  MvDown = kTrue
End Function

Function MvDrop (ByVal Player As Integer) As Integer
  If Not Game(Player).Dropping Then
    MvDrop = Game(Player).CurY - Game(Player).Top(Game(Player).CurX)
    Game(Player).Dropping = kTrue
  End If
End Function

Sub MvLeftRight (ByVal Player As Integer, ByVal r As Integer)
  Dim As Integer i, newX
  newX = Game(Player).CurX + IIf(r, 1, -1)
  If newX < 0 Or newX > 5 Then Exit Sub
  If Game(Player).Top(newX) > Game(Player).CurY Then Exit Sub
  For i = 0 To 2
    If i + Game(Player).CurY < 12 Then
      ShowJewel(Player, Game(Player).CurX, i + Game(Player).CurY, 0)
      ShowJewel(Player, newX, i + Game(Player).CurY, Game(Player).Cur(i))
    End If
  Next i
  Game(Player).CurX = newX  
End Sub

#Define MvLeft(Player) MvLeftRight((Player), kFalse)
#Define MvRight(Player) MvLeftRight((Player), kTrue)

Sub RotateJewel (ByVal Player As Integer)
  Dim As Integer i, temp
  temp = Game(Player).Cur(0)
  Game(Player).Cur(0) = Game(Player).Cur(1)
  Game(Player).Cur(1) = Game(Player).Cur(2)
  Game(Player).Cur(2) = temp
  For i = 0 To 2
    If i + Game(Player).CurY < 12 Then
      ShowJewel(Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i))
    End If
  Next i
End Sub


Sub NewRecord (Diff As Integer, Ini As String, Score As Integer, Jewels As Integer)
  Dim As Integer i
  If Score > High(Diff, 10).Score Then
    i = 10
    Do While Score > High(Diff, i - 1).Score
      High(Diff, i) = High(Diff, i - 1)
      i -= 1
      If i = 1 Then Exit Do
    Loop
    High(Diff, i).Score = Score
    High(Diff, i).Ini = Ini
    High(Diff, i).Jewels = Jewels
  End If
End Sub


Sub NameLeft (ByVal Player As Integer)
  If (Game(Player).PlaceStatus And 3) > 1 Then
    ShowName Player, Game(Player).PlaceStatus And 3, kFalse
    Game(Player).PlaceStatus -= 1
    ShowName Player, Game(Player).PlaceStatus And 3, kTrue
  End If
End Sub

Sub NameRight (ByVal Player As Integer)
  Dim As Integer x, y
  If (Game(Player).PlaceStatus And 3) < 3 Then
    ShowName Player, Game(Player).PlaceStatus And 3, kFalse
    Game(Player).PlaceStatus += 1
    ShowName Player, Game(Player).PlaceStatus And 3, kTrue
  Else
    NewRecord Game(Player).Diff, Game(Player).Ini, Game(Player).Score, Game(Player).Jewels
    Game(Player).PlaceStatus = (Game(Player).PlaceStatus And 4) + 16
    For y = 5 To 8
      For x = 1 To 4
        ShowJewel(Player, x, y, 0)
      Next x
    Next y
    Game(Player).Action = GameOverMsg
  End If
End Sub

Sub NameUpDown (ByVal Player As Integer, ByVal down As Integer)
  Dim As Integer a
  a = Instr(NameStr, Mid(Game(Player).Ini, Game(Player).PlaceStatus And 3, 1))
  a = IIf(down, (a + Len(NameStr) - 2) Mod Len(NameStr) + 1, a Mod Len(NameStr) + 1)  
  Game(Player).Ini[(Game(Player).PlaceStatus And 3) - 1] = NameStr[a-1]
  ShowName Player, Game(Player).PlaceStatus And 3, kTrue
End Sub

#Define NameDown(Player) NameUpDown((Player), kTrue)
#Define NameUp(Player) NameUpDown((Player), kFalse)


Sub ClearBuf (ByVal Player As Integer)
  Game(Player).LeftKeyBuf = 0
  Game(Player).RightKeyBuf = 0
  Game(Player).RotateBuf = 0
  Game(Player).DropBuf = 0
End Sub

Sub ClearPlayer (ByVal Player As Integer)

  Dim As Integer x, y
  For x = 0 To 5
    For y = 0 To 14
      Game(Player).Board(x, y) = 0
    Next y
    Game(Player).Top(x) = 0
  Next x

  Game(Player).Jewels = 0
  Game(Player).TilesPlayed = 0
  Game(Player).CurLv = Game(Player).Lv
  Game(Player).Score = 0
  Game(Player).Chains = 1
  Game(Player).Place = 0
  Game(Player).PlaceStatus = 0
  Game(1 - Player).PlaceStatus = Game(1 - Player).PlaceStatus And &HFFFB

  PrintScore Player
  PrintLv Player
  PrintDiff Player
  PrintJewels Player

End Sub

Sub CountDemand (ByVal Player As Integer, ByVal x As Integer, ByVal y As Integer, Demand() As Integer)
  Dim As Integer a, i, xInc, yInc, DemOn(1 To 6)
  For i = 0 To 3
    xInc = IIf(i, 2-i, 0)
    yInc = IIf(i, 1, 0)
    If x + xInc < 6 And x + xInc >= 0 And y >= -yInc Then
      a = Game(Player).Board(x + xInc, y + yInc)
      If a Then
        If Not DemOn(a) And x + 2 * xInc < 6 And x + 2 * xInc >= 0 And y >= -2 * yInc Then
          If a = Game(Player).Board(x + 2 * xInc, y + 2 * yInc) Then
            Demand(a) += 1
            DemOn(a) = kTrue
          End If
        End If
        If Not DemOn(a) And x - xInc < 6 And x - xInc >= 0 And y >= yInc Then
          If a = Game(Player).Board(x - xInc, y - yInc) Then
            Demand(a) += 1
            DemOn(a) = kTrue
          End If
        End If
      End If
    End If
    If x - 2 * xInc < 6 And x - 2 * xInc >= 0 And y >= 2 * yInc Then
      a = Game(Player).Board(x - xInc, y - yInc)
      If a Then
        If Not DemOn(a) Then
          If a = Game(Player).Board(x - 2 * xInc, y - 2 * yInc) Then
            Demand(a) += 1
            DemOn(a) = kTrue
          End If
        End If
      End If
    End If
  Next i
End Sub

Sub GenJewel (ByVal Player As Integer)

  Dim As Integer a, i, x, y, Count, Same
  Dim As Integer Demand(1 To 6)   'Demand(i) > 0 means jewel i will not appear

  If Game(Player).TilesPlayed Mod 100 = 99 Then
    For i = 0 To 2
      Game(Player).NextJewel(i) = 7
    Next i
  Else
    Select Case Game(Player).Diff
      Case 0
        For i = 0 To 2
          Game(Player).NextJewel(i) = Int(Rnd * 4) + 1
        Next i
      Case 1
        For i = 0 To 2
          Game(Player).NextJewel(i) = Int(Rnd * 5) + 1
        Next i
      Case 2
        For i = 0 To 2
          Game(Player).NextJewel(i) = Int(Rnd * 6) + 1
        Next i
      Case 3
        For x = 0 To 5
          For y = Game(Player).Top(x) To Game(Player).Top(x) + 2
            If y <= 12 Then CountDemand Player, x, y, Demand()
          Next y
        Next x

        Count = 0
        For i = 1 To 6
          If Demand(i) Then Count += 1
        Next i

        Select Case Rnd
          Case Is < .01
            Same = 3
          Case Is < .1
            Same = 2
          Case Else
            Same = 1
        End Select

        For i = 3 + Same To Count
          Do
            a = Int(Rnd * 6 + 1)
          Loop Until Demand(a)
          Demand(a) = 0
        Next i

        For i = 0 To 3 - Same
          Do
            a = Int(Rnd * 6 + 1)
          Loop While Demand(a)
          Game(Player).NextJewel(i) = a
          Demand(a) = 1
        Next i

        For i = 4 - Same To 2
          Game(Player).NextJewel(i) = Game(Player).NextJewel(0)
        Next i

        If Same = 2 Then
          Select Case Int(Rnd * 3)
            Case 0
              Swap Game(Player).NextJewel(0), Game(Player).NextJewel(1)
            Case 1
              Swap Game(Player).NextJewel(1), Game(Player).NextJewel(2)
          End Select
        End If

    End Select
  End If

  ShowNext (Player)
  Game(Player).TilesPlayed += 1
  Game(Player).NextOK = kTrue

End Sub

Sub Init ()
  Randomize Timer, 3
  ClearPlayer (0)
  ClearPlayer (1)
  Game(0).Ini = "   "
  Game(1).Ini = "   "
End Sub

Sub Main ()

  Dim As String*2 kbd
  Dim As Integer i, Finished, Tick, CurP
  Dim As Integer a, x, y, count, xInc, yInc
  Dim As Integer Sink
  Dim As Longint OldTimer, NewTimer
  Dim As fb.EVENT e

  Do
    Do While ScreenEvent(@e)
      If e.Type = fb.EVENT_KEY_PRESS Then
        Select Case e.scancode
          Case fb.SC_LEFT: Game(0).LeftKeyBuf += 1
          Case fb.SC_RIGHT: Game(0).RightKeyBuf += 1
          Case fb.SC_UP: Game(0).RotateBuf += 1
          Case &h4C: Game(0).RotateBuf += 1  ' &h4C = keypad 5
          Case 0: If MultiKey(&h4C) Then Game(0).RotateBuf += 1
          Case fb.SC_DOWN: Game(0).DropBuf += 1
          Case fb.SC_A: Game(1).LeftKeyBuf += 1
          Case fb.SC_D: Game(1).RightKeyBuf += 1
          Case fb.SC_S: Game(1).RotateBuf += 1
          Case fb.SC_X: Game(1).DropBuf += 1
          Case 1: If e.ascii = 27 Then Finished = kTrue
        End Select
      ElseIf e.Type = fb.EVENT_WINDOW_CLOSE Then
        Finished = kTrue
      End If
    Loop
    NewTimer = Int(Timer * 18.2) ' ticks per second (18.2 = compatible w/ old version)
    Tick = NewTimer <> OldTimer
    If Tick Then
      For i = 0 To 1
        If Game(i).TimeWait Then Game(i).TimeWait -= 1
        If Game(i).LeftKeyWait Then Game(i).LeftKeyWait -= 1
        If Game(i).RightKeyWait Then Game(i).RightKeyWait -= 1
        If Game(i).RotateWait Then Game(i).RotateWait -= 1
        If Game(i).DropWait Then Game(i).DropWait -= 1
      Next i
      OldTimer = NewTimer
    End If
    For CurP = 0 To 1
      Select Case Game(CurP).Action
        Case Selecting
          If Game(CurP).LeftKeyBuf Then
            Game(CurP).Lv = (Game(CurP).Lv + 1) Mod 10
            Game(CurP).CurLv = Game(CurP).Lv
            PrintLv CurP
            Game(CurP).LeftKeyBuf -= 1
          End If
          If Game(CurP).RightKeyBuf Then
            Game(CurP).Diff = (Game(CurP).Diff + 1) Mod 4
            ClShowHigh CurP
            PrintDiff CurP
            Game(CurP).RightKeyBuf -= 1
          End If
          If Game(CurP).RotateBuf Then
            ClShowHigh CurP
            GenJewel CurP
            For i = 0 To 2
              Game(CurP).Cur(i) = Game(CurP).NextJewel(i)
            Next i
            Game(CurP).NextOK = kFalse
            Game(CurP).CurX = 3
            Game(CurP).CurY = 12
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
            Game(CurP).Action = Moving
            Game(CurP).RotateBuf -= 1
            Game(CurP).DropBuf = 0
          End If
          If Game(CurP).DropBuf Then
            ShowHigh CurP
            Game(CurP).DropBuf -= 1
          End If

        Case Moving
          If Game(CurP).LeftKeyBuf > 0 And Not Game(CurP).Dropping Then
            MvLeft (CurP)
            Game(CurP).LeftKeyWait = 4
            Game(CurP).LeftKeyBuf -= 1
          End If
          If Game(CurP).RightKeyBuf > 0 And Not Game(CurP).Dropping Then
            MvRight (CurP)
            Game(CurP).RightKeyWait = 4
            Game(CurP).RightKeyBuf -= 1
          End If
          If Game(CurP).RotateBuf > 0 And Not Game(CurP).Dropping Then
            RotateJewel CurP
            Game(CurP).RotateBuf -= 1
          End If

          If Game(CurP).LeftKey And Game(CurP).LeftKeyWait = 0 And Not Game(CurP).RightKey And Tick Then
            If Not Game(CurP).Dropping Then MvLeft (CurP)
          End If
          If Game(CurP).RightKey And Game(CurP).RightKeyWait = 0 And Not Game(CurP).LeftKey And Tick Then
            If Not Game(CurP).Dropping Then MvRight (CurP)
          End If

          If Game(CurP).DropBuf > 0 And Game(CurP).LeftKeyBuf = 0 And Game(CurP).RightKeyBuf = 0 And Game(CurP).RotateBuf = 0 Then
            Game(CurP).Score = Game(CurP).Score + (Game(CurP).CurLv + 1) * MvDrop(CurP)
            Game(CurP).DropBuf -= 1
          End If

          If Game(CurP).TimeWait = 0 Or Game(CurP).Dropping And Tick Then
            If MvDown(CurP) Then
              If Game(CurP).CurY = 9 Then GenJewel CurP
            Else
              If Game(CurP).Dropping Then PrintScore CurP
              Game(CurP).Dropping = kFalse
              If Game(CurP).Cur(0) = 7 Then
                For i = 0 To 2
                  Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY + i) = 15
                Next i
                Game(CurP).Top(Game(CurP).CurX) += 3
                Game(CurP).Action = Eating2
              Else
                For i = 0 To 2
                  Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY + i) = Game(CurP).Cur(i)
                Next i
                Game(CurP).Top(Game(CurP).CurX) += 3
                Game(CurP).Action = Eating
              End If
            End If
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
          End If

        Case Eating
          Count = 0
          yInc = -1
          xInc = 1
          Do
            For y = -2 * (yInc = -1) To 12
              For x = 0 To 5 - 2 * xInc
                a = Game(CurP).Board(x, y) And 7
                If a <> 0 And a = (Game(CurP).Board(x + xInc, y + yInc) And 7) And _
                              a = (Game(CurP).Board(x + 2 * xInc, y + 2 * yInc) And 7) Then
                  For i = 0 To 2
                    Game(CurP).Board(x + i * xInc, y + i * yInc) Or= 8
                  Next i
                  Count += 1
                End If
              Next x
            Next y
            xInc += 1
            If xInc = 2 Then xInc = 0: yInc += 1
            If yInc = 0 Then xInc = 1
          Loop Until yInc = 2
          If Count Then
            Game(CurP).Score = Game(CurP).Score + Count * 30 * (Game(CurP).CurLv + 1) * Game(CurP).Chains
            Game(CurP).Chains += 1
            Game(CurP).TimeWait = 5
            Game(CurP).Action = Marking
          Else
            If Game(CurP).Jewels \ 50 > Game(CurP).CurLv And Game(CurP).CurLv < 9 Then
              Game(CurP).CurLv = Game(CurP).Jewels \ 50
              PrintLv CurP
            End If
            If Not Game(CurP).NextOK Then GenJewel CurP
            Game(CurP).NextOK = kFalse
            Game(CurP).Chains = 1
            Game(CurP).CurX = 3
            Game(CurP).CurY = 12
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
            Game(CurP).Action = Moving

            For i = 0 To 5
              If Game(CurP).Top(i) > 12 Then
                Game(CurP).Action = GameOver
                Game(CurP).TimeWait = 16
                Exit For
              End If
            Next i
            For i = 0 To 2
              Game(CurP).Cur(i) = Game(CurP).NextJewel(i)
            Next i
          End If

        Case Eating2
          If Game(CurP).CurY > 0 Then
            Count = 0
            a = Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY - 1)
            For y = 0 To 11
              For x = 0 To 5
                If Game(CurP).Board(x, y) = a Then
                  Game(CurP).Board(x, y) = a Or 8
                  Count += 1
                End If
              Next x
            Next y
            Game(CurP).Score = Game(CurP).Score + Count * 10 * Game(CurP).CurLv
          End If
          Game(CurP).Chains = 2
          Game(CurP).TimeWait = 5
          Game(CurP).Action = Marking

        Case Marking
          If Tick Then
            For x = 0 To 5
              For y = 0 To Game(CurP).Top(x) - 1
                If y = 12 Then Exit For
                If Game(CurP).Board(x, y) And 8 Then
                  ShowJewel(CurP, x, y, IIf(Game(CurP).TimeWait And 1, Game(CurP).Board(x, y) And 7, 0))
                End If
              Next y
            Next x
            If Game(CurP).TimeWait = 0 Then
              Game(CurP).TimeWait = 5
              Game(CurP).Action = Clearing
            End If
          End If

        Case Clearing
          If Tick Then
            If Game(CurP).TimeWait Then
              i = 12 - Game(CurP).TimeWait 
              For x = 0 To 5
                For y = 0 To Game(CurP).Top(x) - 1
                  If (Game(CurP).Board(x, y) And 8) <> 0 And y < 12 Then
                    ShowJewel(CurP, x, y, i)
                  End If
                Next y
              Next x
            Else
              For x = 0 To 5
                For y = 0 To Game(CurP).Top(x) - 1
                  If Game(CurP).Board(x, y) And 8 Then
                    If y < 12 Then ShowJewel(CurP, x, y, 0)
                    Game(CurP).Board(x, y) = 0
                    Game(CurP).Jewels += 1
                  End If
                Next y
              Next x
              PrintScore CurP
              PrintJewels CurP
              Game(CurP).Action = Sinking
            End If
          End If

        Case Sinking
          If Tick Then
            Sink = kFalse
            For x = 0 To 5
              Do While Game(CurP).Top(x) > 0
                If Game(CurP).Board(x, Game(CurP).Top(x) - 1) <> 0 Then Exit Do
                Game(CurP).Top(x) -= 1
              Loop
              y = 0
              While y < Game(CurP).Top(x) And Game(CurP).Board(x, y) <> 0
                y += 1
              Wend
              If y < Game(CurP).Top(x) Then
                Game(CurP).Top(x) -= 1
                While y < Game(CurP).Top(x)
                  If Game(CurP).Board(x, y) <> Game(CurP).Board(x, y + 1) Then
                    Game(CurP).Board(x, y) = Game(CurP).Board(x, y + 1)
                    If y < 12 Then ShowJewel(CurP, x, y, Game(CurP).Board(x, y))
                    Sink = kTrue
                  End If
                  y += 1
                Wend
                Game(CurP).Board(x, y) = 0
                If y < 12 Then ShowJewel(CurP, x, y, 0)
              End If
            Next x
            If Not Sink Then Game(CurP).Action = Eating
          End If

        Case GameOver
          If Tick Then
            For x = 0 To 5
              If Game(CurP).TimeWait > 3 Then ShowJewel(CurP, x, 15 - Game(CurP).TimeWait, 8)
              If Game(CurP).TimeWait > 2 And Game(CurP).TimeWait < 15 Then ShowJewel(CurP, x, 14 - Game(CurP).TimeWait, 9)
              If Game(CurP).TimeWait > 1 And Game(CurP).TimeWait < 14 Then ShowJewel(CurP, x, 13 - Game(CurP).TimeWait, 10)
              If Game(CurP).TimeWait > 0 And Game(CurP).TimeWait < 13 Then ShowJewel(CurP, x, 12 - Game(CurP).TimeWait, 11)
              If Game(CurP).TimeWait < 12 Then ShowJewel(CurP, x, 11 - Game(CurP).TimeWait, 0)
            Next x
            If Game(CurP).TimeWait = 0 Then
              Game(CurP).Place = 11
              Do While Game(CurP).Score > High(Game(CurP).Diff, Game(CurP).Place - 1).Score
                Game(CurP).Place -= 1
                If Game(CurP).Place = 1 Then Exit Do
              Loop
              If Game(CurP).Diff = Game(1 - CurP).Diff Then
                If Game(CurP).Score < Game(1 - CurP).Score Then
                  Game(CurP).Place += 1
                  If Game(CurP).Place = 11 Then
                    NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
                  End If
                End If
              End If
              If Game(CurP).Place <= 10 Then
                Game(CurP).Action = HighMsg
                Game(CurP).PlaceStatus = 9
                If Game(CurP).Diff = Game(1 - CurP).Diff Then
                  If Game(CurP).Score < Game(1 - CurP).Score Then
                    Game(CurP).PlaceStatus = 13
                  End If
                End If
              Else
                Game(CurP).Action = GameOverMsg
              End If
            End If
            ClearBuf CurP
          End If

        Case HighMsg
          HighMessage CurP
          Game(CurP).Action = EnterName

        Case EnterName
          If Game(CurP).LeftKeyBuf Then
            NameLeft CurP
            Game(CurP).LeftKeyBuf -= 1
          End If
          If Game(CurP).RightKeyBuf Then
            NameRight CurP
            Game(CurP).RightKeyBuf -= 1
          End If
          If Game(CurP).RotateBuf Then
            NameUp (CurP)
            Game(CurP).RotateWait = 4
            Game(CurP).RotateBuf -= 1
          End If
          If Game(CurP).DropBuf Then
            NameDown (CurP)
            Game(CurP).DropWait = 4
            Game(CurP).DropBuf -= 1
          End If
              
          If Game(CurP).Rotate And Game(CurP).RotateWait = 0 And Not Game(CurP).Drop And Tick Then
            NameUp(CurP)
          End If
          If Game(CurP).Drop And Game(CurP).DropWait = 0 And Not Game(CurP).Rotate And Tick Then
            NameDown(CurP)
          End If

          If Game(CurP).Diff = Game(1 - CurP).Diff And (Game(CurP).PlaceStatus And 4) = 0 Then
            If Game(CurP).Score < Game(1 - CurP).Score Then
              Game(CurP).PlaceStatus Or= 4
              Game(CurP).Place += 1
              If Game(CurP).Place = 11 Then
                NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
                Game(CurP).Action = OutMsg
              Else
                HighMessage CurP
              End If
            End If
          End If

        Case OutMsg
          NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
          Game(CurP).PlaceStatus = Game(CurP).PlaceStatus And 4 + 16
          OutMessage CurP
          Game(CurP).TimeWait = 90
          Game(CurP).Action = ResetDelay

        Case GameOverMsg
          GameOverMessage CurP
          Game(CurP).TimeWait = 90
          Game(CurP).Action = ResetDelay

        Case ResetDelay
          If Game(CurP).TimeWait = 0 Then
            ClGOverMes CurP
            ClearNext CurP
            ClearPlayer CurP
            ClearBuf CurP
            Game(CurP).Action = Selecting
          End If

      End Select
    Next CurP
    
    Sleep (1) ' sleep after every iteration - otherwise the program will use 100% CPU power
  Loop Until Finished
End Sub

Sub ReadTop ()
  Open hiFile For Binary Access Read As #1
  Get #1, , High(0, 1), 40
  Close #1
End Sub

Sub UpDateTop ()
  Open hiFile For Binary Access Write As #1
  Put #1, , High(0, 1), 40
  Close #1
End Sub


' MAIN PROGRAM
'turn on number lock in selected platforms (todo)
GrInit
DrawBoard
ReadTop
Init
Main

'update highscore with progress of unfinished games and exit
Dim i As Integer
For i = 0 To 1
  Select Case Game(i).PlaceStatus And 24
    Case 0: NewRecord Game(i).Diff, "   ", Game(i).Score, Game(i).Jewels
    Case 8: NewRecord Game(i).Diff, Game(i).Ini, Game(i).Score, Game(i).Jewels
  End Select
Next i
UpDateTop
GrEnd

'turn off number lock in selected platforms (todo)

End